const { DOM_TAGS, SVG_TAGS } = require("./constants");

export function isUpperCase(str) {
  return /^[A-Z_-]+$/.test(str);
}

function isNativeDOMTag(str) {
  return DOM_TAGS.includes(str);
}

function isSvgTag(str) {
  return SVG_TAGS.includes(str);
}

function containAllAttributes(attributeNames) {
  const attrs = ["value", "other"];
  return attrs.every(attr => attributeNames.includes(attr));
}

function isLinguiTags(str, attributeNames) {
  if (str === "Trans") {
    return true;
  }
  return (
    ["Plural", "Select"].includes(str) && containAllAttributes(attributeNames)
  );
}

const blacklistAttrs = ["aria-label", "value"];
export function isAllowedDOMAttr(tag, attr, attributeNames) {
  if (isSvgTag(tag)) return true;
  if (isNativeDOMTag(tag)) {
    return !blacklistAttrs.includes(attr);
  }
  if (isLinguiTags(tag, attributeNames)) {
    return true;
  }
  return false;
}
